;-------------
; Menu 1
;-------------
;  item selection menu
;---------------------

itemMenu:
 ld hl,0
 ld (pencol),hl
 ld hl,itemText
 call vputsApp

 ld de,plotsscreen+85		; 7*12+1
 ld hl,plotsscreen+84
 ld (hl),255
 ld bc,11
 ldir				; black line

 ld hl,plotsscreen+103		; 8*12+7
 ld b,55
 ld de,12
execItemLine2:
 ld (hl),1
 add hl,de
 djnz execItemLine2

 ; show the names

 ld hl,256*10+74
 ld (pencol),hl
 call loadAppvarInDE
 ex de,hl
 call vputsApp

 ld hl,256*24+74
 ld (pencol),hl
 ld hl,(appvarPointer)
 ld de,30
 add hl,de
 call vputsApp

 ld hl,256*38+74
 ld (pencol),hl
 ld hl,(appvarPointer)
 ld de,60
 add hl,de
 call vputsApp

 ; show hit points

 ld hl,256*17+66
 ld (pencol),hl
 ld hl,(appvarPointer)
 ld de,6
 add hl,de
 call showHL

 ld hl,256*31+66
 ld (pencol),hl
 ld hl,(appvarPointer)
 ld de,36
 add hl,de
 call showHL

 ld hl,256*45+66
 ld (pencol),hl
 ld hl,(appvarPointer)
 ld de,66
 add hl,de
 call showHL

 ; get start of items
 ld hl,(appvarPointer)
 ld de,90
 add hl,de

 call offsetItems

 call showAllItems
 jp returnToRedraw

offsetItems:
 ; offset to start of list
 ld a,(itemOffset)
 or a
 ret z

 ld b,a
itemOffsetLoop:
 ld de,3
 add hl,de
 djnz itemOffsetLoop
 ret

;-----------------
; Item Routines
;--------------

; show all of the items
showAllItems:
 ld a,9
showAllItemsLoop:
 push af
  ld (itemPointer),hl
  call displayItem
  ld hl,(itemPointer)
  inc hl
  inc hl
  inc hl
 pop af
 
 add a,7
 cp 59
 jr c,showAllItemsLoop
 ret



;**********
;* display item
;*  input:
;*   a - y location for item
;*   hl - item
;**********
displayItem:
 ld (penrow),a

 ld a,(hl)
 or a
 ret z

 ; set where Item icon will be displayed
 ld hl,plotsscreen+1
 ld a,(penrow)
 ld b,a
 ld de,12
rowMULTloop:
 add hl,de
 djnz rowMULTloop

 ex de,hl		; de contains location to display at

;  db <item Type ID>,<item name pointer>,<item quantity>

 ; is there an item?
 ld hl,(itemPointer)
 ld a,(hl)
 ld b,a
 or a
 ret z
 inc hl

 ; do we have 0 quantity of that item?
 ld a,(hl)
 or a
 ret z

 ; show Item icon
 ld hl,itemSprites
 ld a,b
 dec a
 jr z,displayItemNow

 push de
  ld b,a
findItemSpriteLoop:
  ld de,6
  add hl,de
  djnz findItemSpriteLoop
 pop de

 ; display the icon
displayItemNow:
 call align6

 ; SHOW ITEM NAME
 ld hl,(itemPointer)
 inc hl
 ld e,(hl)
 dec e
 sla e
 ld hl,itemNameVectors
 ld d,0
 add hl,de

 ld e,(hl)
 inc hl
 ld d,(hl)
 ex de,hl
 ld a,16
 ld (pencol),a
 call vputsApp

 ld hl,itemSeperator
 call vputsApp

 ; SHOW ITEM QUANTITY
 ld hl,(itemPointer)
 inc hl
 inc hl
 ld a,(hl)
 B_CALL setxxop1
 ld a,2
 B_CALL dispop1a
 ret


addItem:
 push bc
  call loadAppvarInDE
 pop bc
 ld hl,90
 add hl,de

locateItemLoop:
 ld a,(hl)
 cp b
 jr nz,nextLocateItem1

 inc hl
 ld a,(hl)
 cp c
 jr z,addItemIncrement

 inc hl
 inc hl
 jr locateItemLoop 

nextLocateItem1:
 or a
 jr z,addNewItem

 inc hl
 inc hl
 inc hl
 jr locateItemLoop

addItemIncrement:
 inc hl
 inc (hl)
 ret

addNewItem:
 ld (hl),b
 inc hl
 ld (hl),c
 inc hl
 ld (hl),1
 ret
 
