appvarPointer .equ saveSScreen+14

appVarSize .equ 2048		; sounds like a good number

; APP VAR FORMAT

; name = RPGDATA
; data:

;0  CHAR 1 - 30 bytes
;   name - 6 bytes
;   HP/HP max - 4 bytes
;10 exp - 2 bytes
;   level - 1 byte
;   strength, speed, vitality, magic, hit, evade -= 6 bytes
;   picture pointer - 1 byte
;20 EQUIP 1 - 10 bytes
;   rhand, lhand, head, body, relic

;30 CHAR 2 - 30 bytes
;   name - 6 bytes
;   HP/HP max - 4 bytes
;40 exp - 2 bytes
;   level - 1 byte
;   strength, speed, vitality, magic, hit, evade -= 6 bytes
;   picture pointer - 1 byte
;50 EQUIP 2 - 10 bytes
;   rhand, lhand, head, body, relic

;60 CHAR 3 - 30 bytes
;   name - 6 bytes
;   HP/HP max - 4 bytes
;70 exp - 2 bytes
;   level - 1 byte
;   strength, speed, vitality, magic, hit, evade -= 6 bytes
;   picture pointer - 1 byte
;80 EQUIP 3 - 10 bytes
;   rhand, lhand, head, body, relic


;90 ITEM LIST
;    twenty 3 byte entries
;  db <item Type ID>,<item name pointer>,<item quantity>

;150 gold - 2 bytes

;160 MAP 1 START


;----------------------------

setupAppvarData:
 call loadCharacterData
 call loadItemData

 ;maps
 call loadAppvarInDE
 ld hl,overworldMap
 add hl,de

 ex de,hl
 ld hl,mapList
 ld bc,mapTotalSpace
 ldir
 ret

loadCharacterData:
 call loadAppvarInDE
 ld hl,char1
 ld bc,90
 ldir
 ret

loadItemData:
 call loadAppvarInDE
 ld hl,90
 add hl,de
 ex de,hl
 ld hl,item_list
 ld bc,60
 ldir
 ret

getMapStart:
 ; we need to load the appvar
 call loadAppvarInDE
 ld hl,(mapStart)
 add hl,de

 ld de,160
 add hl,de
 ret


loadAppvarInDE:
 B_CALL ZeroOP1  ; Reset OP1 
 ld hl,AppVarName 
 rst rMOV9TOOP1 
 B_CALL ChkFindSym ; Look it up 
 jr c,createAppVar  ; Return if no Str1 

 ; is it an appVar?
 and 1Fh
 cp AppVarObj
 jr nz,createAppVar

 ; is it archived?
 ld a,b
 or a
 jr z,dontUnArchiveAppVar

 B_CALL Arc_Unarc
; jr loadScoresInDE

dontUnArchiveAppVar:
 inc de
 inc de								; go to beginning of actual data
 ex de,hl
 ld (appvarPointer),hl
 ex de,hl
 ret 

createAppVar:
 ld hl,AppVarName 
 rst rMOV9TOOP1 
 ld hl,appVarSize 						; var size
 B_CALL CreateAppVar 
 jr dontUnArchiveAppVar

AppVarName: db AppVarObj,"RPGDATA",0
Subtype: db 04Ah, 065h, 073h, 073h
