; battleitem.asm

; show short list of all items
showItemsBattle:
 ld a,44
showItemsBattleLoop:
 push af
  ld (itemPointer),hl
  call displayItem
  ld hl,(itemPointer)
  inc hl
  inc hl
  inc hl
 pop af
 
 add a,7
 cp 59
 jr c,showItemsBattleLoop
 ret

ITEMselected:
 xor a

setupBattleItemMenu:
 xor a
 ld (cursorPos),a
 ld (itemOffset),a
returnFromBSC:
 ld (itemSelect),a

 ld a,9
 ld (cursorState),a
 ld a,30			; offset by 1, b/c state 10 uses same routine
 ld (cursorMax),a	; zone for cursor
 xor a
 ld (cursorVideo),a	; reverse video (0=no,1=yes)

 ld de,plotsscreen+528	; de = where to draw cursor at
 ld hl,cursorTable

 ld b,3
setupBattleTableLoop3:
 ld (hl),e
 inc hl
 ld (hl),d
 inc hl

 push hl
  ld hl,7*12
  add hl,de
  ex de,hl
 pop hl
 djnz setupBattleTableLoop3
 jp drawBattleLoop

battleItemMenu:
 ; clear current character arrow
 call clearCharBattleArrows

 ; clear only part of the screen

 ld hl,plotsscreen+504
 ld (hl),255
 inc hl
 ld (hl),255
 inc hl
 ld (hl),255
 inc hl
 ld (hl),255
 inc hl
 ld (hl),255
 inc hl
 ld (hl),255
 inc hl
 ld (hl),255
 inc hl
 ld (hl),11100000b

 ld hl,plotsscreen+516
 ld b,21
clearBattleItemArea:
 ld (hl),0
 inc hl
 ld (hl),0
 inc hl
 ld (hl),0
 inc hl
 ld (hl),0
 inc hl
 ld (hl),0
 inc hl
 ld (hl),0
 inc hl
 ld (hl),0
 inc hl
 ld a,(hl)
 and 11111b
 or 100000b
 ld (hl),a

 inc hl
 inc hl
 inc hl
 inc hl
 inc hl
 djnz clearBattleItemArea

 call loadAppvarInDE
 ld hl,90
 add hl,de

 call offsetItems

 call showItemsBattle

 call displayCursor
 B_CALL grbufcpy

 ei
 halt
 halt
 halt

 ; read keypresses
 B_CALL getcsc
 cp sk2nd
 jp z,itemBattlePress2nd

 cp skUp
 jr z,itemBattleCursorUp
 cp skDown
 jr z,itemBattleCursorDown
 cp skMode
 jp nz,battleItemMenu

 ld a,0FFh
 ld (itemSelect),a
 jp drawBattleLoop

itemBattleCursorUp:
 ld a,(cursorPos)
 or a
 jr z,scroll_IBC_UP
 dec a
 ld (cursorPos),a
 jp battleItemMenu

itemBattleCursorDown:
 ld a,(cursorPos)
 cp 2
 jp z,scroll_IBC_DOWN
 inc a
 ld (cursorPos),a
 jp battleItemMenu

scroll_IBC_UP:
 ld a,(itemOffset)
 or a
 jp z,battleItemMenu
 dec a
 ld (itemOffset),a
 jp battleItemMenu

scroll_IBC_DOWN:
 ld a,(cursorMax)
 ld b,a
 ld a,(itemOffset)
 cp b
 jp z,battleItemMenu
 inc a
 ld (itemOffset),a
 jp battleItemMenu

itemBattlePress2nd:
 ; select the item

 call loadAppvarInDE
 ld hl,90
 add hl,de

 ld a,(itemOffset)
 ld b,a
 ld a,(cursorPos)
 add a,b
 or a
 jr z,skipItemPress2ndOffset
 ld b,a
 call itemOffsetLoop

skipItemPress2ndOffset:
 ; item use class
 ;   must be Potion (hl=1)
 ld a,(hl)
 cp 1
 jp nz,battleItemMenu

 ; what type of potion
 inc hl
 ld a,(hl)
 cp 3
 jr c,battleUseItem

 ; potion
 ; xpotion are okay

 jp battleItemMenu

battleUseItem:
 dec hl
 ld (itemSelection),hl
 ld a,(itemOffset)
 ld b,a
 ld a,(cursorPos)
 ;add a,b
 ld (itemXPos),a

 call waitUntilKEYup

 ld a,(itemXPos)
 add a,a
 ld e,a
 ld d,0
 ld hl,cursorTable
 add hl,de
 ld e,(hl)
 inc hl
 ld d,(hl)
 ld hl,animCursor
 call align6


 ; once the character is selected...

;------------------------
; BATTLE SELECT CHARACTER
;------------------------
; IN: graphics
; OUT: (charSelect) = char selected
;------------------------
battleSelectCharacter:
 xor a
 ld (cursorPos),a

 ld hl,cursorTable

 ld de,plotsscreen+57
 ld (hl),e
 inc hl
 ld (hl),d
 inc hl

 ld de,plotsscreen+247
 ld (hl),e
 inc hl
 ld (hl),d
 inc hl

 ld de,plotsscreen+417
 ld (hl),e
 inc hl
 ld (hl),d

bscLoop:
 call clearCharBattleArrows
 call displayCursor

 B_CALL grbufcpy

 ei
 halt
 halt
 halt
 halt
 halt

 B_CALL getcsc

 cp sk2nd
 jp z,itemBSC2nd
 cp skUp
 jr z,itemBSCup
 cp skDown
 jr z,itemBSCdown
 cp skMode
 jp nz,bscLoop

 ld a,(itemXPos)
 ld (cursorPos),a
 xor a
 jp returnFromBSC

itemBSCup:
 ld a,(cursorPos)
 or a
 jp z,bscLoop
 dec a
 ld (cursorPos),a
 jp bscLoop

itemBSCdown:
 ld a,(cursorPos)
 cp 2
 jp z,bscLoop
 inc a
 ld (cursorPos),a
 jp bscLoop

itemBSC2nd:
 ; set your state to be 4
 ld a,(charsReadyToAttack)
 call findBattleChar
 ld (hl),4

 ; ADD ITEM TO ATTACK QUEUE
 ; the item is actually used here
 ld de,8
 ld hl,attackQueue
 call getLastEntryOfAttackQ

 ; get character using the item
 ld a,(charsReadyToAttack)
 ld (hl),a
 inc hl

 ; character receiving item
 ld a,(cursorPos)
 inc a
 ld (hl),a
 inc hl

 ; ITEM = 3
 ld (hl),3
 inc hl

 ; add ?
 inc hl

 ; pointer to item
 ex de,hl
  ld hl,(itemSelection)
 ex de,hl
 ld (hl),e
 inc hl
 ld (hl),d

 call updateCharsReadyToAttack
 call setupBattleCursor

 ld a,0FFh
 ld (itemSelect),a
 call waitUntilKEYup
 jp drawBattleLoop


clearCharBattleArrows:
 ld a,72
 ld e,4
 ld hl,blankSprite
 call sprite8

 ld a,56
 ld e,20
 ld hl,blankSprite
 call sprite8

 ld a,72
 ld e,34
 ld hl,blankSprite
 jp sprite8


; FINISH ITEM STATE
finishItemState:
 ; locate item in memory
 ld hl,(attackQueue+4)
 inc hl
 ld a,(hl)
 ld (itemNumber),a 

  ld a,(attackQueue+1) 
  ld l,a
  ld h,0
  xor a
  ld (currow),a
  ld (curcol),a
  B_CALL disphl
 
 ld a,(attackQueue+1) 
 call findBattleChar
 ld de,6
 add hl,de

 call isHPfull

 push hl
  push de
   ex de,hl
	push bc
 ;  B_CALL disphl
   pop hl
;	B_CALL disphl
 ;  B_CALL getkey
  pop de
 pop hl

 ld bc,100

 ld a,(itemNumber)
 cp 1
 jr z,usePotionBattle

 ld bc,250

usePotionBattle:
 ex de,hl
  add hl,bc

 ex de,hl

 dec hl
 dec hl

 ld (hl),d
 dec hl
 ld (hl),e
 call fixHP

 call removeItem
 ret

