moveItem:
 ld (temp),a
 cp b
 jr z,executeItemSelection

 ld a,b
 ; switch the two items
 ;  hl=previous
 ;  de=new

 call getItemPosition
 push hl
  ld a,(temp)
  call getItemPosition
 pop de

 ld b,3
itemMoveLoop:
 ld a,(de)
 ld c,(hl)
 ld (hl),a
 ld a,c
 ld (de),a
 inc hl
 inc de
 djnz itemMoveLoop

resetItemSelection:
 ld a,0FFh
 ld (itemSelect),a
 jp redraw

executeItemSelection:
 ; check to see if it is a potion or equipment
 call getItemPosition

 ld a,(hl)	; 1st byte is Item Type ID
 cp 1
 jr z,itemSelectionOKAY
 cp 7
 jr z,useItem7
 jp redraw

itemSelectionOKAY:
 ld (itemSelection),hl		; save the item...

 ld a,2
 ld (cursorMax),a
 xor a
 ld (cursorPos),a
 ld (cursorScroll),a

 ld de,plotsscreen+128
 ld hl,cursorTable

 call setHLinc
 ld de,plotsscreen+308
 call setHLinc
 ld de,plotsscreen+476
 call setHLinc

 ld a,4
 ld (cursorState),a
 jr resetItemSelection

useItem7:
 ld (itemSelection),hl
 inc hl
 ld a,(hl)
 cp 4
 jr z,useTent
 jp redraw

useItem:
 ld hl,(itemSelection)
 inc hl
 ld a,(hl)
 ld (itemNumber),a
 cp 3
 jr c,usePotion
 jp exitMenu

; use POTION
; use X-POTION
usePotion:
 ld a,(cursorPos)
 call findChar
 ld de,6
 add hl,de

 call isHPfull
 jr c,cannotUsePotion

 ld bc,100

 ld a,(itemNumber)
 cp 1
 jr z,usingPotion

 ld bc,250

usingPotion:
 ex de,hl
  add hl,bc  
 ex de,hl   ; de= new HP
 
 dec hl
 dec hl

 ld (hl),d
 dec hl
 ld (hl),e 
 call fixHP

 call removeItem
 jp exitMenu

cannotUsePotion:
 ; display error
 xor a
 ld (curcol),a
 ld (currow),a
 ld hl,itemError1
 call putsApp
 B_CALL getkey
 jp exitMenu

itemError1: .asciz "HP FULL"

; use TENT
useTent:
 call restoreHP

 call removeItem
 jp exitMenu

restoreHP:
 call loadAppvarInDE
 ld hl,9
 add hl,de
 call getFullHP

 ld hl,(appvarPointer)
 ld de,39
 add hl,de
 call getFullHP

 ld hl,(appvarPointer)
 ld de,69
 add hl,de
 call getFullHP
 ret

getFullHP:
 ld d,(hl)
 dec hl
 ld e,(hl)
 dec hl
 ld (hl),d
 dec hl
 ld (hl),e
 ret

removeItem:
 ld hl,(itemSelection)
 inc hl
 inc hl
 ld a,(hl)
 dec a
 ld (hl),a
 ret nz

 dec hl
 ld (hl),0
 dec hl
 ld (hl),0
 ret