; equates

tilemapBufferSize .equ 1320
tilemapRows .equ 14

; all of these are from the start of AppVar!

scrollX .equ saveSScreen
scrollY .equ scrollX+1
TILEstart .equ scrollY+1
mapXpos .equ TILEstart+2
mapYpos .equ mapXpos+1

setupOverworld:
 ld hl,map
 ld (TILEstart),hl

 xor a
 ld (scrollX),a
 ld (scrollY),a

 call reloadTempMap

overworldLoop:
 B_CALL GrBufClr

 call drawmap

 B_CALL GrBufCpy

 ei
 halt

 B_CALL GetCSC

 cp skDown
 push af
 call z,moveDown
 pop af
 cp skUp
 push af
 call z,moveUp
 pop af
 cp skRight
 push af
 call z,moveRight
 pop af
 cp skLeft
 push af
 call z,moveLeft
 pop af

 cp skAlpha
 jp z,setupMenuScreen

 cp skMode
 jr nz,overworldLoop

 jp setupMenuScreen

moveDown:
 ld a,(mapYpos)
 add a,4
 ld (mapYpos),a
 cp 24
 ret c

 sub 12
 ld (mapYpos),a

 ld hl,(TILEstart)
 ld de,tilemapRows
 add hl,de

fixY:
 ld (TILEstart),hl
 jp reloadTempMap

moveLeft:
 ld a,(mapXpos)
 sub 4
 jr c,scrollLEFT
 ld (mapXpos),a
 ret

scrollLEFT:
 add a,13
 ld (scrollX),a

 ld hl,(TILEstart)
 dec hl

fixX:
 ld (TILEstart),hl
 jp reloadTempMap

moveRight:
 ld a,(mapXpos)
 add a,4
 ld (mapXpos),a
 cp 24
 ret c

 sub 12
 ld (mapXpos),a

 ld hl,(TILEstart)
 inc hl
 jr fixX

moveUp:
 ld a,(mapYpos)
 sub 4
 jr c,scrollUP
 ld (mapYpos),a
 ret

scrollUP:
 add a,13
 ld (scrollY),a

 ld hl,(TILEstart)
 ld de,tilemapRows
 xor a
 sbc hl,de
 jr fixY


drawmap:
 call loadAppvarInDE
 ex de,hl
 ld a,(scrollY)

 ; we must move (scrollY) number of columns down
 ;  to accomplish this we offset the start of the data we read from tempMap

 ; the formula for the length of a row is:

 ; 12 + SpriteWidth/4
 ;ex: for a 12x12 sprite, 12+12/4 = 15

 inc a

 ld de,15
 ld b,a			; we don't need to worry about the zero case
 or a
 jr z,skipScrollMAPy

scrollMapYloop:
 add hl,de
 djnz scrollMapYloop

skipScrollMAPy:
 ld a,(scrollX)
 ld d,0		; Do x/8
 ld e,a
 srl e
 srl e
 srl e
 add hl,de	; hl, the sprite pointer, is now offset

 ld de,plotsscreen

 ld a,(scrollX)
 and 7
 jr z,Aligned

 push hl
 ex de,hl
 pop ix

 ld e,64	; lines painted
 ld d,a		; shift d bits per line

LineLOOP:
 
 ld b,12
shift_IT:
 push bc
 ld b,(ix+0)
 inc ix
 ld c,(ix+0)
 push de
 ld e,0
shiftLOOP:
 sla b
 rlc c
 rl e
 dec d
 jp nz,shiftLOOP

 ld a,e
 and c
 pop de

 or b             ; Write line to graphbuf
 ld (hl),a

 inc hl
 pop bc
 djnz shift_IT

 ld bc,3           ; Calculate next line address
 add ix,bc
 dec e
 jr nz,LineLOOP        ; Next line
 ret


Aligned:
 ld b,64	; b = 64 lines
alignedLOOP:
 push bc
 ld bc,12	; paint this line on the screen
 ldir
 ld bc,3
 add hl,bc	; advance pointer 64 bits, to the next start.
 pop bc
 djnz alignedLOOP
 ret


reloadTempMap:
 ; always aligned

 ; a 10*7 map = bordered 8*5 map

 ; clear it
 call loadAppvarInDE
 push de
 pop hl
 inc de
 ld (hl),0
 ld bc,1319
 ldir

 call loadAppvarInDE
 ld hl,(TILEstart)

 ld c,7
mapColLoop:

 ld b,10
mapRowLoop:
 push hl
 push bc
 ld a,(hl)
 or a
 jp z,skipSprite2

 ld c,a

 ld hl,tilemapSprites-24
 push de
  ld de,24		; 12 * 2
getMapSprite:
  add hl,de
  dec c
  jr nz,getMapSprite
 pop de
 push de

 ld a,10
 sub b
 ld b,12
 and 1
 jr nz,nonAlignedBlock

alignedBlock:
 push bc
 ld a,(de)
 or (hl)
 ld (de),a

 inc hl
 inc de
 ld a,(de)
 or (hl)
 ld (de),a

 inc hl
 push hl
  ld hl,14
  add hl,de
  ex de,hl
 pop hl
 pop bc
 djnz alignedBlock
 pop de

 jr skipSprite

nonAlignedBlock:
 push bc

 ld a,(hl)
 and 15
 ld b,a

 xor a
 ld a,(hl)
 sra a
 sra a
 sra a
 sra a
 and 15
 ld c,a
 ld a,(de)
 or c
 ld (de),a

 inc hl
 inc de

 xor a

 rl b
 rl b
 rl b
 rl b
 ld a,(de)
 or b
 ld (de),a

 xor a
 ld a,(hl)
 rra
 rra
 rra
 rra
 ld b,a
 ld a,(de)
 or b
 ld (de),a

 inc hl
 push hl
  ld hl,14
  add hl,de
  ex de,hl
 pop hl

 pop bc
 djnz nonAlignedBlock
 pop de
 inc de

skipSprite:
 inc de

 pop bc
 pop hl
 inc hl
 djnz mapRowLoop

 push de
  ld de,tilemapRows-10
  add hl,de		; we just added an extra one above
 pop de

 push hl
  ld hl,12*14-3
  add hl,de
  ex de,hl
 pop hl

 dec c
 jp nz,mapColLoop

 ret

skipSprite2:
 ld a,10
 sub b
 and 1
 jr z,skipSprite

 inc de
 jr skipSprite


map:
 db 4,4,0,2,2,0,5,5,0,0,0,4,0,2
 db 0,0,0,4,0,0,0,0,0,2,0,4,0,2
 db 4,0,4,0,3,0,0,4,0,2,0,4,0,2
 db 4,4,4,4,3,3,0,0,0,2,0,4,0,2
 db 2,0,0,0,3,0,0,4,0,2,0,4,0,2
 db 2,0,0,0,0,0,0,0,0,2,0,4,0,2
 db 2,2,2,2,2,2,2,2,2,2,0,4,0,2
 db 2,0,0,0,3,0,0,4,0,2,0,4,0,2
 db 2,0,0,0,0,0,0,0,0,2,0,4,0,2
 db 2,0,0,0,3,0,0,4,0,2,0,4,0,2
 db 2,0,0,0,0,0,0,0,0,2,0,4,0,2


tilemapSprites:
 db 00000000b,00000000b
 db 00000100b,00000000b
 db 01001010b,00000000b
 db 10100100b,00000000b
 db 01001010b,00000000b
 db 01010101b,00000000b
 db 01010010b,00000000b
 db 00000010b,01000000b
 db 00000100b,10100000b
 db 00001010b,01000000b
 db 00000100b,10000000b
 db 00000100b,10000000b

;flowers ***
 db 00000000b,00000000b
 db 00000100b,00000000b
 db 01001010b,00000000b
 db 10100100b,00000000b
 db 01001010b,00000000b
 db 01010101b,00000000b
 db 01010010b,00000000b
 db 00000010b,01000000b
 db 00000100b,10100000b
 db 00001010b,01000000b
 db 00000100b,10000000b
 db 00000100b,10000000b

;desert
 db 10100000b,00010000b
 db 01000000b,00100000b
 db 10000000b,01010000b
 db 00000000b,00100000b
 db 00000000b,10100000b
 db 00000000b,01010000b
 db 00000001b,10100000b
 db 00000010b,01000000b
 db 00000001b,10000000b
 db 00011010b,01000000b
 db 00010110b,10000000b
 db 10101000b,00000000b

;floor
 db 11111110b,00100000b
 db 10100001b,00000000b
 db 10010100b,11110000b
 db 01001010b,00010000b
 db 01010001b,00010000b
 db 01000000b,00110000b
 db 01001111b,11110000b
 db 00111100b,00100000b
 db 11000100b,10010000b
 db 00010100b,01010000b
 db 01100101b,01010000b
 db 00000100b,10110000b

;Cut Grass
 db 0,0
 db 0,0
 db 00010000b,00000000b
 db 01010100b,00000000b
 db 00101000b,00000000b
 db 0,0
 db 0,0
 db 0,0
 db 00000000b,01000000b
 db 00000001b,01010000b
 db 00000000b,10100000b
 db 0,0

;Un-Cut grass
 db 0,0
 db 10000010b,00000000b
 db 01001001b,00100000b
 db 01011001b,01100000b
 db 01010001b,01000000b
 db 00010000b,01000000b
 db 0,0
 db 10000010b,00000000b
 db 01001001b,00100000b
 db 01011001b,01100000b
 db 01010001b,01000000b
 db 00010000b,01000000b